include	ht48e30.inc

include 7segglob.inc

extern _CGRAM:byte						
extern _init7seg:near				
extern _cls7seg:near
extern _findk:near
extern findk0:byte
extern _DISP_F:byte
extern _LAST_K:byte
extern _init_softtimers:near
extern _TK_TIMERS:byte,_SEC_TIMERS:byte

data	 .section	'data'  


reset	.section at 0 'code'              		

		ORG 00h					
		jmp start


code	.section 'code'              		
start:  clr	PC			; 
        clr PAC					; PA0-7 = outputs
        set PBC					; PB0-7 = inputs
		clr	PBC.1				; PB1 = output
		clr	PBC.2				; PB2 = output
	    clr PCC					; PC0-7 = outputs
		set PGC					; PG0 = input

		call _init7seg
		call _init_softtimers

		set INTC.2					; habilita int del timer
		set INTC.0					; habilita interrupciones

		set _DISP_F.DISPON

loop:
	IFDEF USELEDS
		mov A,(1+080h)
	ELSE
		mov A,(1+040h)
	ENDIF
		mov _CGRAM[0],A
	IFDEF USELEDS
		mov A,(2+040h)
	ELSE
		mov A,(2)
	ENDIF
		mov _CGRAM[1],A
		mov A,(3+080h)
		mov _CGRAM[2],A
		mov A,(4)
		mov _CGRAM[3],A
		set _DISP_F.BEEP
lp:    	snz _DISP_F.ASYNC
		jmp lp1
		clr _DISP_F.ASYNC
		inc _CGRAM[3]
		mov A,_CGRAM[3]
		xor A,10
		clr ACC
		sz Z
		mov _CGRAM[3],A
		mov A,_LAST_K
		mov findk0,A
		sz findk0				; wait for key press
		jmp shkbd
lp1:	sz _TK_TIMERS[3]
		jmp lp2
		mov A,2
		xorm A,PB
		mov A,28
		mov _TK_TIMERS[3],A
		jmp lp
lp2:	sz _SEC_TIMERS[4]
		jmp lp
		mov A,4
		xorm A,PB
		mov A,5
		mov _SEC_TIMERS[4],A
		jmp lp
shkbd:	call _cls7seg			; clear display
		clr _DISP_F.BEEP
		clr BUZZER
shkbdl:	call _findk				; get key
		sz ACC.7				; skip if unknown
		jmp loop
		mov _CGRAM[1],A			; show key
		sz _LAST_K				; wait for key release
		jmp shkbdl
		jmp loop		



	   	end

